import matplotlib
import matplotlib.pyplot as plot
import numpy as np
import mysql.connector
import array
import sys
import time
from sys import exit
from matplotlib import cm
from scipy import interpolate
from mpl_toolkits.mplot3d import Axes3D
from scipy.stats import norm

#################################################################

# Controllo numero argomenti a linea di comando
#if (len(sys.argv) != 5):
#	print ("Syntax:")
#	print ("dataDisplay <Server address> <Min channel> <Max channel> <Number of Channels>")
#	exit (1)
	
# Estrazione dalla linea di comando dei parametri di lavoro
hostAddress = sys.argv[1]

# Definizione della finestra
fig = plot.figure("GRASS - Data Image", figsize=(13.5, 6.5))

# Compone la query per estrarre il timeStamp piu recente
sqlScw = "select acqTimeStamp from grassdb.events order by acqTimeStamp DESC LIMIT 1"

loopStatus = "Running"
acqTimeStamp = ""

# Definisce i vettori riga e colonna del rivelatore
channelDataX = [0] * 8
channelDataY = [0] * 8

while (loopStatus != "Exit"):

	conn = mysql.connector.connect(
								user='grass', \
								password='hemera2022', \
								host=hostAddress, \
								database='grassdb' \
								)

	# Crea un cursore per il database grassdb
	cursor = conn.cursor()

	# Esegue la query
	status = cursor.execute(sqlScw)
	
	# Legge l'ultimo valore di acqTimeStamp
	acqTimeStampTuple = cursor.fetchone()
	conn.close()
	
	# Se esiste almeno un set di dati lo processa
	if (acqTimeStampTuple):
	
		# Se il set di dati e' nuovo lo processa
		if (acqTimeStamp != str(acqTimeStampTuple [0])):

			acqTimeStamp = str(acqTimeStampTuple [0])

			conn = mysql.connector.connect(
										user='grass', \
										password='hemera2022', \
										host=hostAddress, \
										database='grassdb' \
										)

			# Crea un cursore per il database grassdb
			cursor = conn.cursor()
			
			# Preleva l'intero set di dati
			query = "SELECT * FROM events WHERE acqTimeStamp = " \
					+ \
					"'" \
					+ \
					acqTimeStamp +"'"
			
			cursor.execute(query)
			selectOutput = cursor.fetchall()
	
			# Valore receivedFrames
			query = "SELECT COUNT(DISTINCT acqTimeStamp) FROM events"
	
			# Esegue la query
			cursor.execute(query)
	
			# Accede al risultato della query
			receivedFrames = cursor.fetchone()
			conn.close()
			
			image = np.zeros( (8,8)  )
			totalEnergy = 0

			for row in selectOutput:

				maxXval = 0
				maxYval = 0

				for channel in range(0,8):
					channelDataX [channel] = int(row [channel + 3])
					totalEnergy = totalEnergy + channelDataX [channel]
					if (channelDataX [channel] > maxXval):
						maxXval = channelDataX [channel]
						maxXpos = channel

				for channel in range(0,8):
					channelDataY [channel] = int(row [channel + 11])
					totalEnergy = totalEnergy + channelDataY [channel]
					if (channelDataY [channel] > maxYval):
						maxYval = channelDataY [channel]
						maxYpos = channel
						
				image [maxYpos][maxXpos] = image [maxYpos][maxXpos] + totalEnergy

			plot.clf()
			
			# DATA FRAME TIME
			dataFrameTime = \
							acqTimeStamp[8:10] + \
							"/" + \
							acqTimeStamp[5:7] + \
							"/" + \
							acqTimeStamp[0:4] + \
							" " + \
							acqTimeStamp[11:13] + \
							":" + \
							acqTimeStamp[14:16] + \
							":" + \
							acqTimeStamp[17:19]
							
			plot.suptitle(dataFrameTime+" Received frames: "+str(receivedFrames[0]), fontsize=12, fontweight='bold')
			
			ax = fig.add_subplot(2,1,1)
			
#			plot.imshow(image, interpolation='bilinear')
#			plot.imshow(image, cmap=cm.gray, interpolation='nearest')
			plot.imshow(image, cmap=cm.gray,interpolation='gaussian')

####			xx, yy = np.mgrid[0:image.shape[0], 0:image.shape[1]]
			ax = fig.add_subplot(2,1,2, projection='3d')
			
####			ax.plot_surface(xx, yy, image, cmap=cm.jet,cstride=1, antialiased=True)
#			ax.plot_surface(xx, yy, znew, cmap=cm.tab20,rstride=1, cstride=1, alpha=None,antialiased=True)
#			ax.plot_surface(xx, yy, znew, cmap=cm.gnuplot,alpha=None,antialiased=True)
#			ax.plot_surface(xx, yy, znew,alpha=None,antialiased=True)

			xpos = [range(image.shape[0])]
			ypos = [range(image.shape[1])]
			xpos, ypos = np.meshgrid(xpos, ypos)
			xpos = xpos.flatten('F')
			ypos = ypos.flatten('F')
			zpos = np.zeros_like(xpos)

			dx = 0.5 * np.ones_like(zpos)
			dy = dx.copy()
			dz = image.flatten()
			
			ax.bar3d(xpos, ypos, zpos, dx, dy, dz, color='r', zsort='average')


			plot.draw()

	plot.pause(5.0)
			
# Chiude la connessione con il server mysql
plot.close()
